//
//  ViewController.swift
//  CD10-Multithreading
//
//  Created by bulko on 3/14/25.
//

import UIKit

class ViewController: UIViewController {
    
    private var queue: DispatchQueue!
    
    var dot: UIView!
    var xLeft: Double!
    var xRight: Double!
    var y: Double!

    override func viewDidLoad() {
        super.viewDidLoad()
        
        // size of dot:  initially a square, 100 x 100
        let dotHeight = 100.0
        let dotWidth = 100.0
        
        // two horizontal positions of the TOP LEFT corner of the dot
        // leave a space 1/2 the width of the dor from the sides of
        // the screen
        
        xLeft = dotWidth / 2.0
        xRight = self.view.bounds.width - 1.5 * dotWidth
        
        // one vertical position:  centered vertically on the screen
        
        y = (self.view.bounds.height / 2.0) - (dotHeight / 2.0)
        
        dot = UIView(frame: CGRect(
            x: xLeft,
            y: y,
            width: dotWidth,
            height: dotHeight))
        
        dot.backgroundColor = .red
        dot.layer.cornerRadius = 50
        
        view.addSubview(dot)
        
        queue = DispatchQueue(label: "myQueue", qos:.utility)
        
        queue.async {
            self.moveBlock()
        }
        
    }

    func moveBlock() {
        
        var toggle = "left"
        
        while true {
            
            usleep(300000)  // 300,000 ms or 0.3 sec
            
            if toggle == "left" {
                toggle = "right"
                DispatchQueue.main.async {
                    self.dot.frame.origin.x = self.xRight
                }
            } else {
                toggle = "left"
                DispatchQueue.main.async {
                    self.dot.frame.origin.x = self.xLeft
                }
            }
            
        }
        
    }

}

